# Team Munich 2022 Software Tool(s)

<img src="OSCAR/igem-oscar/oscar/media/icons/oscar-dark.svg" alt="logo" style="width:100px;">

Hey there, we did some modeling and built a responsive web app (OSCAR) for our software project.

The source code for each project can be found in the corresponding folders.

More details about what we did can be found on our wiki:

### • <a href="https://2022.igem.wiki/munich/model">Modeling</a>
### • <a href="https://2022.igem.wiki/munich/software">OSCAR</a>

## To check out OSCAR:
The app has to be hosted on AWS since the iGEM hosting services do not allow for a Django backend and database.\\
The AWS instance could be down. If so, the screenshots on the wiki should give a great overview of what the app looks like.

Link: <a href="https://www.oscar-db.org/">https://www.oscar-db.org/</a>


---
---
## To run OSCAR locally on your machine:

Probably won't work on your system without some debugging...

Dependencies:
- Python
- node
- Postgres

1. launch Postgres
2. create a database called oscar_backend
3. import SQL file to a database called oscar_database
4. follow the installation steps below


```bash
python3 -m venv {path}
```


Where path is the directory where you would like to create a python virtual environment.


Go to the correct directory:


```
cd OSCAR/igem-oscar/oscar
```

```
source {into the directory where you created venv}
```


```
pip install -r requirements.txt
```


```
cd OSCAR/igem-oscar/oscar/frontend
```

```
npm install
```


```
npm run dev
```


```
cd OSCAR/igem-oscar/oscar/
```


```
python3 manage.py runserver
```


Enter the URL (localhost:8000) into your browser.

<img src="OSCAR/igem-oscar/oscar/media/images/oscar.png" alt="logo" style="width:100px;">

You made it to the bottom!
